widget_quintupoltrobol/dashboard/urls.py
from django.urls import path
from .views import WidgetUserDetailView, WidgetUserCreateView, WidgetUserUpdateView

from .views import pageview

urlpatterns = [
    path('dashboard/', pageview, name='pageview'),
    path('widgetusers/<int:pk>/details', WidgetUserDetailView.as_view(), name='widgetuser-details'),
    path('widgetusers/add', WidgetUserCreateView.as_view(), name='widgetuser-add'),
    path('widgetusers/<int:pk>/edit', WidgetUserUpdateView.as_view(), name='widgetuser-edit'),
]

app_name = "dashboard"

widget_quintupoltrobol/forum/urls.py
from django.urls import path
from .views import pageview, ForumpostDetailView, ForumpostCreateView, ForumpostUpdateView

urlpatterns = [
    path('', pageview, name='pageview'),
    path('forumposts/<int:pk>/details/', ForumpostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add/', ForumpostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit/', ForumpostUpdateView.as_view(), name='forumpost-edit'),
]

app_name = "forum"

widget_quintupoltrobol/widget_quintupoltrobol/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('widget_calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('admin/', admin.site.urls),
]

widget_quintupoltrobol/dashboard/models.py
from django.db import models
from django.urls import reverse

class Department(models.Model):
        dept_name = models.CharField(max_length=300)
        home_unit = models.CharField(max_length=300)

        def __str__(self):
                return self.dept_name

class WidgetUser(models.Model):
        first_name = models.CharField(max_length=300)
        middle_name = models.CharField(max_length=300)
        last_name = models.CharField(max_length=300)
        department = models.ForeignKey(Department, on_delete=models.CASCADE)

        def __str__(self):
                return '{} {} {}'.format(self.first_name, self.middle_name, self.last_name)
        
        def get_absolute_url(self):
            return reverse('dashboard:widgetuser-details', kwargs={"pk": self.pk})
        

widget_quintupoltrobol/dashboard/forms.py
from django import forms
from .models import WidgetUser

class WidgetUserForm(forms.ModelForm):
    class Meta:
            model = WidgetUser
            fields = ['first_name', 'middle_name', 'last_name', 'department',]

widget_quintupoltrobol/dashboard/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView
from .models import Department, WidgetUser

def pageview(request):
    departments = Department.objects.all()
    widgetusers = WidgetUser.objects.all()

    return render(request, 'dashboard/dashboard.html', {'departments': departments, 'widgetusers': widgetusers})

class WidgetUserDetailView(DetailView):
    def get(self, request, pk):
        user = WidgetUser.objects.get(pk=pk)
        department = user.department
        return render(request, 'dashboard/widgetuser-details.html', {'department': department, 'user': user})
    
class WidgetUserCreateView(CreateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-add.html'

class WidgetUserUpdateView(UpdateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-edit.html'
    

widget_quintupoltrobol/dashboard/templates/dashboard/dashboard.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Widget v2{% endblock %}
{% block content %}
<h2>Welcome to Widget!</h2>
<h3>Widget Users:</h3>
{% for user in widgetusers %}
    <a href="{{ user.get_absolute_url }}">{{user.last_name}}, {{user.first_name}}</a><br>
{% endfor %}
<br>
<button type="button"><a href="{% url 'dashboard:widgetuser-add' %}"> Add Widget User </a></button><br><br>
<a href="{% url 'announcements:pageview' %}">Announcement Board</a><br>
<a href="{% url 'forum:pageview' %}">Forum</a><br>
<a href="{% url 'assignments:pageview' %}">Assignments</a><br>
<a href="{% url 'widget_calendar:pageview' %}">Calendar</a><br>
{% endblock %}

widget_quintupoltrobol/dashboard/templates/dashboard/widgetuser-add.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Add Widget User{% endblock %}
{% block content %}
<h2>Add a new Widget user:</h2>
<p>
<form action='' method="POST">
    {% csrf_token %}
    {{ form.first_name.label_tag }}
    {{ form.first_name }}<br><br>
    {{ form.middle_name.label_tag }}
    {{ form.middle_name }}<br><br>
    {{ form.last_name.label_tag }}
    {{ form.last_name }}<br><br>
    Department, Home Unit:
    {{ form.department }}<br><br>
    <input type="submit" value="Add Widget User">
</form>
</p>
{% endblock %}

widget_quintupoltrobol/dashboard/templates/dashboard/widgetuser-details.html
{% extends 'base.html' %}
{% load static %}
{% block title %}{{ user.last_name }}, {{user.first_name}}{% endblock %}
{% block content %}
<h2>{{ user.first_name }} {{ user.middle_name }} {{ user.last_name }}</h2>
<h3>{{ department.dept_name }}</h3>
<h3>{{ department.home_unit }}</h3>

<br>
<form action='edit'>
    <input type="submit" value="Edit Widget User"/>
</form>
{% endblock %}

widget_quintupoltrobol/dashboard/templates/dashboard/widgetuser-edit.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Edit Widget User{% endblock %}
{% block content %}
<h2>Edit Widget user:</h2>
<p>
<form action='' method="POST">
    {% csrf_token %}
    {{ form.first_name.label_tag }}
    {{ form.first_name }}<br><br>
    {{ form.middle_name.label_tag }}
    {{ form.middle_name }}<br><br>
    {{ form.last_name.label_tag }}
    {{ form.last_name }}<br><br>
    Department, Home Unit:
    {{ form.department }}<br><br>
    <input type="submit" value="Save Changes to Widget User">
</form>
</p>
{% endblock %}